# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class AuditTopic(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        AuditTopic - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'id': 'str',
            'max_cached_messages': 'int'
        }

        self.attribute_map = {
            'id': 'id',
            'max_cached_messages': 'max_cached_messages'
        }

        self._id = None
        self._max_cached_messages = None

    @property
    def id(self):
        """
        Gets the id of this AuditTopic.
        Specifies the system-provided ID for the audit topic.

        :return: The id of this AuditTopic.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this AuditTopic.
        Specifies the system-provided ID for the audit topic.

        :param id: The id of this AuditTopic.
        :type: str
        """
        
        self._id = id

    @property
    def max_cached_messages(self):
        """
        Gets the max_cached_messages of this AuditTopic.
        Specifies the maximum number of messages that can be sent and received at the same time. Messages that are sent and received at the same time can be lost if a system crash occurs. You can prevent message loss by setting this property to 0, which sets audit logs to synchronous.

        :return: The max_cached_messages of this AuditTopic.
        :rtype: int
        """
        return self._max_cached_messages

    @max_cached_messages.setter
    def max_cached_messages(self, max_cached_messages):
        """
        Sets the max_cached_messages of this AuditTopic.
        Specifies the maximum number of messages that can be sent and received at the same time. Messages that are sent and received at the same time can be lost if a system crash occurs. You can prevent message loss by setting this property to 0, which sets audit logs to synchronous.

        :param max_cached_messages: The max_cached_messages of this AuditTopic.
        :type: int
        """
        
        if max_cached_messages is not None and max_cached_messages < 0.0:
            raise ValueError("Invalid value for `max_cached_messages`, must be a value greater than or equal to `0.0`")

        self._max_cached_messages = max_cached_messages

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

