# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class ChangelistLins(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        ChangelistLins - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'atime': 'ChangelistLinsCtime',
            'ctime': 'ChangelistLinsCtime',
            'id': 'str',
            'mtime': 'ChangelistLinsCtime',
            'path': 'str',
            'size': 'int',
            'type': 'str'
        }

        self.attribute_map = {
            'atime': 'atime',
            'ctime': 'ctime',
            'id': 'id',
            'mtime': 'mtime',
            'path': 'path',
            'size': 'size',
            'type': 'type'
        }

        self._atime = None
        self._ctime = None
        self._id = None
        self._mtime = None
        self._path = None
        self._size = None
        self._type = None

    @property
    def atime(self):
        """
        Gets the atime of this ChangelistLins.
        

        :return: The atime of this ChangelistLins.
        :rtype: ChangelistLinsCtime
        """
        return self._atime

    @atime.setter
    def atime(self, atime):
        """
        Sets the atime of this ChangelistLins.
        

        :param atime: The atime of this ChangelistLins.
        :type: ChangelistLinsCtime
        """
        
        self._atime = atime

    @property
    def ctime(self):
        """
        Gets the ctime of this ChangelistLins.
        

        :return: The ctime of this ChangelistLins.
        :rtype: ChangelistLinsCtime
        """
        return self._ctime

    @ctime.setter
    def ctime(self, ctime):
        """
        Sets the ctime of this ChangelistLins.
        

        :param ctime: The ctime of this ChangelistLins.
        :type: ChangelistLinsCtime
        """
        
        self._ctime = ctime

    @property
    def id(self):
        """
        Gets the id of this ChangelistLins.
        The LIN number of the file associated with the entry.

        :return: The id of this ChangelistLins.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this ChangelistLins.
        The LIN number of the file associated with the entry.

        :param id: The id of this ChangelistLins.
        :type: str
        """
        
        self._id = id

    @property
    def mtime(self):
        """
        Gets the mtime of this ChangelistLins.
        

        :return: The mtime of this ChangelistLins.
        :rtype: ChangelistLinsCtime
        """
        return self._mtime

    @mtime.setter
    def mtime(self, mtime):
        """
        Sets the mtime of this ChangelistLins.
        

        :param mtime: The mtime of this ChangelistLins.
        :type: ChangelistLinsCtime
        """
        
        self._mtime = mtime

    @property
    def path(self):
        """
        Gets the path of this ChangelistLins.
        The path to the file associated with the entry.

        :return: The path of this ChangelistLins.
        :rtype: str
        """
        return self._path

    @path.setter
    def path(self, path):
        """
        Sets the path of this ChangelistLins.
        The path to the file associated with the entry.

        :param path: The path of this ChangelistLins.
        :type: str
        """
        
        self._path = path

    @property
    def size(self):
        """
        Gets the size of this ChangelistLins.
        The size of the file associated with the entry.

        :return: The size of this ChangelistLins.
        :rtype: int
        """
        return self._size

    @size.setter
    def size(self, size):
        """
        Sets the size of this ChangelistLins.
        The size of the file associated with the entry.

        :param size: The size of this ChangelistLins.
        :type: int
        """
        
        self._size = size

    @property
    def type(self):
        """
        Gets the type of this ChangelistLins.
        Type of file.

        :return: The type of this ChangelistLins.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Sets the type of this ChangelistLins.
        Type of file.

        :param type: The type of this ChangelistLins.
        :type: str
        """
        
        self._type = type

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

