# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class ProvidersAdsAdsItemExtended(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        ProvidersAdsAdsItemExtended - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'allocate_gids': 'bool',
            'allocate_uids': 'bool',
            'assume_default_domain': 'bool',
            'authentication': 'bool',
            'check_online_interval': 'int',
            'controller_time': 'int',
            'create_home_directory': 'bool',
            'domain_offline_alerts': 'bool',
            'findable_groups': 'list[str]',
            'findable_users': 'list[str]',
            'forest': 'str',
            'groupnet': 'str',
            'home_directory_template': 'str',
            'hostname': 'str',
            'id': 'str',
            'ignore_all_trusts': 'bool',
            'ignored_trusted_domains': 'list[str]',
            'include_trusted_domains': 'list[str]',
            'instance': 'str',
            'ldap_sign_and_seal': 'bool',
            'login_shell': 'str',
            'lookup_domains': 'list[str]',
            'lookup_groups': 'bool',
            'lookup_normalize_groups': 'bool',
            'lookup_normalize_users': 'bool',
            'lookup_users': 'bool',
            'machine_account': 'str',
            'machine_name': 'str',
            'machine_password_changes': 'bool',
            'machine_password_lifespan': 'int',
            'name': 'str',
            'netbios_domain': 'str',
            'node_dc_affinity': 'str',
            'node_dc_affinity_timeout': 'int',
            'nss_enumeration': 'bool',
            'primary_domain': 'str',
            'restrict_findable': 'bool',
            'sfu_support': 'str',
            'site': 'str',
            'status': 'str',
            'store_sfu_mappings': 'bool',
            'system': 'bool',
            'unfindable_groups': 'list[str]',
            'unfindable_users': 'list[str]'
        }

        self.attribute_map = {
            'allocate_gids': 'allocate_gids',
            'allocate_uids': 'allocate_uids',
            'assume_default_domain': 'assume_default_domain',
            'authentication': 'authentication',
            'check_online_interval': 'check_online_interval',
            'controller_time': 'controller_time',
            'create_home_directory': 'create_home_directory',
            'domain_offline_alerts': 'domain_offline_alerts',
            'findable_groups': 'findable_groups',
            'findable_users': 'findable_users',
            'forest': 'forest',
            'groupnet': 'groupnet',
            'home_directory_template': 'home_directory_template',
            'hostname': 'hostname',
            'id': 'id',
            'ignore_all_trusts': 'ignore_all_trusts',
            'ignored_trusted_domains': 'ignored_trusted_domains',
            'include_trusted_domains': 'include_trusted_domains',
            'instance': 'instance',
            'ldap_sign_and_seal': 'ldap_sign_and_seal',
            'login_shell': 'login_shell',
            'lookup_domains': 'lookup_domains',
            'lookup_groups': 'lookup_groups',
            'lookup_normalize_groups': 'lookup_normalize_groups',
            'lookup_normalize_users': 'lookup_normalize_users',
            'lookup_users': 'lookup_users',
            'machine_account': 'machine_account',
            'machine_name': 'machine_name',
            'machine_password_changes': 'machine_password_changes',
            'machine_password_lifespan': 'machine_password_lifespan',
            'name': 'name',
            'netbios_domain': 'netbios_domain',
            'node_dc_affinity': 'node_dc_affinity',
            'node_dc_affinity_timeout': 'node_dc_affinity_timeout',
            'nss_enumeration': 'nss_enumeration',
            'primary_domain': 'primary_domain',
            'restrict_findable': 'restrict_findable',
            'sfu_support': 'sfu_support',
            'site': 'site',
            'status': 'status',
            'store_sfu_mappings': 'store_sfu_mappings',
            'system': 'system',
            'unfindable_groups': 'unfindable_groups',
            'unfindable_users': 'unfindable_users'
        }

        self._allocate_gids = None
        self._allocate_uids = None
        self._assume_default_domain = None
        self._authentication = None
        self._check_online_interval = None
        self._controller_time = None
        self._create_home_directory = None
        self._domain_offline_alerts = None
        self._findable_groups = None
        self._findable_users = None
        self._forest = None
        self._groupnet = None
        self._home_directory_template = None
        self._hostname = None
        self._id = None
        self._ignore_all_trusts = None
        self._ignored_trusted_domains = None
        self._include_trusted_domains = None
        self._instance = None
        self._ldap_sign_and_seal = None
        self._login_shell = None
        self._lookup_domains = None
        self._lookup_groups = None
        self._lookup_normalize_groups = None
        self._lookup_normalize_users = None
        self._lookup_users = None
        self._machine_account = None
        self._machine_name = None
        self._machine_password_changes = None
        self._machine_password_lifespan = None
        self._name = None
        self._netbios_domain = None
        self._node_dc_affinity = None
        self._node_dc_affinity_timeout = None
        self._nss_enumeration = None
        self._primary_domain = None
        self._restrict_findable = None
        self._sfu_support = None
        self._site = None
        self._status = None
        self._store_sfu_mappings = None
        self._system = None
        self._unfindable_groups = None
        self._unfindable_users = None

    @property
    def allocate_gids(self):
        """
        Gets the allocate_gids of this ProvidersAdsAdsItemExtended.
        Allocates an ID for an unmapped Active Directory (ADS) group. ADS groups without GIDs can be proactively assigned a GID by the ID mapper. If the ID mapper option is disabled, GIDs are not proactively assigned, and when a primary group for a user does not include a GID, the system may allocate one. 

        :return: The allocate_gids of this ProvidersAdsAdsItemExtended.
        :rtype: bool
        """
        return self._allocate_gids

    @allocate_gids.setter
    def allocate_gids(self, allocate_gids):
        """
        Sets the allocate_gids of this ProvidersAdsAdsItemExtended.
        Allocates an ID for an unmapped Active Directory (ADS) group. ADS groups without GIDs can be proactively assigned a GID by the ID mapper. If the ID mapper option is disabled, GIDs are not proactively assigned, and when a primary group for a user does not include a GID, the system may allocate one. 

        :param allocate_gids: The allocate_gids of this ProvidersAdsAdsItemExtended.
        :type: bool
        """
        
        self._allocate_gids = allocate_gids

    @property
    def allocate_uids(self):
        """
        Gets the allocate_uids of this ProvidersAdsAdsItemExtended.
        Allocates a user ID for an unmapped Active Directory (ADS) user. ADS users without UIDs can be proactively assigned a UID by the ID mapper. IF the ID mapper option is disabled, UIDs are not proactively assigned, and when an identify for a user does not include a UID, the system may allocate one.

        :return: The allocate_uids of this ProvidersAdsAdsItemExtended.
        :rtype: bool
        """
        return self._allocate_uids

    @allocate_uids.setter
    def allocate_uids(self, allocate_uids):
        """
        Sets the allocate_uids of this ProvidersAdsAdsItemExtended.
        Allocates a user ID for an unmapped Active Directory (ADS) user. ADS users without UIDs can be proactively assigned a UID by the ID mapper. IF the ID mapper option is disabled, UIDs are not proactively assigned, and when an identify for a user does not include a UID, the system may allocate one.

        :param allocate_uids: The allocate_uids of this ProvidersAdsAdsItemExtended.
        :type: bool
        """
        
        self._allocate_uids = allocate_uids

    @property
    def assume_default_domain(self):
        """
        Gets the assume_default_domain of this ProvidersAdsAdsItemExtended.
        Enables lookup of unqualified user names in the primary domain.

        :return: The assume_default_domain of this ProvidersAdsAdsItemExtended.
        :rtype: bool
        """
        return self._assume_default_domain

    @assume_default_domain.setter
    def assume_default_domain(self, assume_default_domain):
        """
        Sets the assume_default_domain of this ProvidersAdsAdsItemExtended.
        Enables lookup of unqualified user names in the primary domain.

        :param assume_default_domain: The assume_default_domain of this ProvidersAdsAdsItemExtended.
        :type: bool
        """
        
        self._assume_default_domain = assume_default_domain

    @property
    def authentication(self):
        """
        Gets the authentication of this ProvidersAdsAdsItemExtended.
        Enables authentication and identity management through the authentication provider.

        :return: The authentication of this ProvidersAdsAdsItemExtended.
        :rtype: bool
        """
        return self._authentication

    @authentication.setter
    def authentication(self, authentication):
        """
        Sets the authentication of this ProvidersAdsAdsItemExtended.
        Enables authentication and identity management through the authentication provider.

        :param authentication: The authentication of this ProvidersAdsAdsItemExtended.
        :type: bool
        """
        
        self._authentication = authentication

    @property
    def check_online_interval(self):
        """
        Gets the check_online_interval of this ProvidersAdsAdsItemExtended.
        Specifies the time in seconds between provider online checks.

        :return: The check_online_interval of this ProvidersAdsAdsItemExtended.
        :rtype: int
        """
        return self._check_online_interval

    @check_online_interval.setter
    def check_online_interval(self, check_online_interval):
        """
        Sets the check_online_interval of this ProvidersAdsAdsItemExtended.
        Specifies the time in seconds between provider online checks.

        :param check_online_interval: The check_online_interval of this ProvidersAdsAdsItemExtended.
        :type: int
        """
        
        self._check_online_interval = check_online_interval

    @property
    def controller_time(self):
        """
        Gets the controller_time of this ProvidersAdsAdsItemExtended.
        Specifies the current time for the domain controllers.

        :return: The controller_time of this ProvidersAdsAdsItemExtended.
        :rtype: int
        """
        return self._controller_time

    @controller_time.setter
    def controller_time(self, controller_time):
        """
        Sets the controller_time of this ProvidersAdsAdsItemExtended.
        Specifies the current time for the domain controllers.

        :param controller_time: The controller_time of this ProvidersAdsAdsItemExtended.
        :type: int
        """
        
        self._controller_time = controller_time

    @property
    def create_home_directory(self):
        """
        Gets the create_home_directory of this ProvidersAdsAdsItemExtended.
        Automatically creates a home directory on the first login.

        :return: The create_home_directory of this ProvidersAdsAdsItemExtended.
        :rtype: bool
        """
        return self._create_home_directory

    @create_home_directory.setter
    def create_home_directory(self, create_home_directory):
        """
        Sets the create_home_directory of this ProvidersAdsAdsItemExtended.
        Automatically creates a home directory on the first login.

        :param create_home_directory: The create_home_directory of this ProvidersAdsAdsItemExtended.
        :type: bool
        """
        
        self._create_home_directory = create_home_directory

    @property
    def domain_offline_alerts(self):
        """
        Gets the domain_offline_alerts of this ProvidersAdsAdsItemExtended.
        Sends an alert if the domain goes offline.

        :return: The domain_offline_alerts of this ProvidersAdsAdsItemExtended.
        :rtype: bool
        """
        return self._domain_offline_alerts

    @domain_offline_alerts.setter
    def domain_offline_alerts(self, domain_offline_alerts):
        """
        Sets the domain_offline_alerts of this ProvidersAdsAdsItemExtended.
        Sends an alert if the domain goes offline.

        :param domain_offline_alerts: The domain_offline_alerts of this ProvidersAdsAdsItemExtended.
        :type: bool
        """
        
        self._domain_offline_alerts = domain_offline_alerts

    @property
    def findable_groups(self):
        """
        Gets the findable_groups of this ProvidersAdsAdsItemExtended.
        Sets list of groups that can be resolved.

        :return: The findable_groups of this ProvidersAdsAdsItemExtended.
        :rtype: list[str]
        """
        return self._findable_groups

    @findable_groups.setter
    def findable_groups(self, findable_groups):
        """
        Sets the findable_groups of this ProvidersAdsAdsItemExtended.
        Sets list of groups that can be resolved.

        :param findable_groups: The findable_groups of this ProvidersAdsAdsItemExtended.
        :type: list[str]
        """
        
        self._findable_groups = findable_groups

    @property
    def findable_users(self):
        """
        Gets the findable_users of this ProvidersAdsAdsItemExtended.
        Sets list of users that can be resolved.

        :return: The findable_users of this ProvidersAdsAdsItemExtended.
        :rtype: list[str]
        """
        return self._findable_users

    @findable_users.setter
    def findable_users(self, findable_users):
        """
        Sets the findable_users of this ProvidersAdsAdsItemExtended.
        Sets list of users that can be resolved.

        :param findable_users: The findable_users of this ProvidersAdsAdsItemExtended.
        :type: list[str]
        """
        
        self._findable_users = findable_users

    @property
    def forest(self):
        """
        Gets the forest of this ProvidersAdsAdsItemExtended.
        Specifies the Active Directory forest.

        :return: The forest of this ProvidersAdsAdsItemExtended.
        :rtype: str
        """
        return self._forest

    @forest.setter
    def forest(self, forest):
        """
        Sets the forest of this ProvidersAdsAdsItemExtended.
        Specifies the Active Directory forest.

        :param forest: The forest of this ProvidersAdsAdsItemExtended.
        :type: str
        """
        
        self._forest = forest

    @property
    def groupnet(self):
        """
        Gets the groupnet of this ProvidersAdsAdsItemExtended.
        Groupnet identifier.

        :return: The groupnet of this ProvidersAdsAdsItemExtended.
        :rtype: str
        """
        return self._groupnet

    @groupnet.setter
    def groupnet(self, groupnet):
        """
        Sets the groupnet of this ProvidersAdsAdsItemExtended.
        Groupnet identifier.

        :param groupnet: The groupnet of this ProvidersAdsAdsItemExtended.
        :type: str
        """
        
        self._groupnet = groupnet

    @property
    def home_directory_template(self):
        """
        Gets the home_directory_template of this ProvidersAdsAdsItemExtended.
        Specifies the path to the home directory template.

        :return: The home_directory_template of this ProvidersAdsAdsItemExtended.
        :rtype: str
        """
        return self._home_directory_template

    @home_directory_template.setter
    def home_directory_template(self, home_directory_template):
        """
        Sets the home_directory_template of this ProvidersAdsAdsItemExtended.
        Specifies the path to the home directory template.

        :param home_directory_template: The home_directory_template of this ProvidersAdsAdsItemExtended.
        :type: str
        """
        
        self._home_directory_template = home_directory_template

    @property
    def hostname(self):
        """
        Gets the hostname of this ProvidersAdsAdsItemExtended.
        Specifies the fully qualified hostname stored in the machine account.

        :return: The hostname of this ProvidersAdsAdsItemExtended.
        :rtype: str
        """
        return self._hostname

    @hostname.setter
    def hostname(self, hostname):
        """
        Sets the hostname of this ProvidersAdsAdsItemExtended.
        Specifies the fully qualified hostname stored in the machine account.

        :param hostname: The hostname of this ProvidersAdsAdsItemExtended.
        :type: str
        """
        
        self._hostname = hostname

    @property
    def id(self):
        """
        Gets the id of this ProvidersAdsAdsItemExtended.
        Specifies the ID of the Active Directory provider instance.

        :return: The id of this ProvidersAdsAdsItemExtended.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this ProvidersAdsAdsItemExtended.
        Specifies the ID of the Active Directory provider instance.

        :param id: The id of this ProvidersAdsAdsItemExtended.
        :type: str
        """
        
        self._id = id

    @property
    def ignore_all_trusts(self):
        """
        Gets the ignore_all_trusts of this ProvidersAdsAdsItemExtended.
        If set to true, ignores all trusted domains.

        :return: The ignore_all_trusts of this ProvidersAdsAdsItemExtended.
        :rtype: bool
        """
        return self._ignore_all_trusts

    @ignore_all_trusts.setter
    def ignore_all_trusts(self, ignore_all_trusts):
        """
        Sets the ignore_all_trusts of this ProvidersAdsAdsItemExtended.
        If set to true, ignores all trusted domains.

        :param ignore_all_trusts: The ignore_all_trusts of this ProvidersAdsAdsItemExtended.
        :type: bool
        """
        
        self._ignore_all_trusts = ignore_all_trusts

    @property
    def ignored_trusted_domains(self):
        """
        Gets the ignored_trusted_domains of this ProvidersAdsAdsItemExtended.
        Includes trusted domains when 'ignore_all_trusts' is set to false.

        :return: The ignored_trusted_domains of this ProvidersAdsAdsItemExtended.
        :rtype: list[str]
        """
        return self._ignored_trusted_domains

    @ignored_trusted_domains.setter
    def ignored_trusted_domains(self, ignored_trusted_domains):
        """
        Sets the ignored_trusted_domains of this ProvidersAdsAdsItemExtended.
        Includes trusted domains when 'ignore_all_trusts' is set to false.

        :param ignored_trusted_domains: The ignored_trusted_domains of this ProvidersAdsAdsItemExtended.
        :type: list[str]
        """
        
        self._ignored_trusted_domains = ignored_trusted_domains

    @property
    def include_trusted_domains(self):
        """
        Gets the include_trusted_domains of this ProvidersAdsAdsItemExtended.
        Includes trusted domains when 'ignore_all_trusts' is set to true.

        :return: The include_trusted_domains of this ProvidersAdsAdsItemExtended.
        :rtype: list[str]
        """
        return self._include_trusted_domains

    @include_trusted_domains.setter
    def include_trusted_domains(self, include_trusted_domains):
        """
        Sets the include_trusted_domains of this ProvidersAdsAdsItemExtended.
        Includes trusted domains when 'ignore_all_trusts' is set to true.

        :param include_trusted_domains: The include_trusted_domains of this ProvidersAdsAdsItemExtended.
        :type: list[str]
        """
        
        self._include_trusted_domains = include_trusted_domains

    @property
    def instance(self):
        """
        Gets the instance of this ProvidersAdsAdsItemExtended.
        Specifies Active Directory provider instnace.

        :return: The instance of this ProvidersAdsAdsItemExtended.
        :rtype: str
        """
        return self._instance

    @instance.setter
    def instance(self, instance):
        """
        Sets the instance of this ProvidersAdsAdsItemExtended.
        Specifies Active Directory provider instnace.

        :param instance: The instance of this ProvidersAdsAdsItemExtended.
        :type: str
        """
        
        self._instance = instance

    @property
    def ldap_sign_and_seal(self):
        """
        Gets the ldap_sign_and_seal of this ProvidersAdsAdsItemExtended.
        Enables encryption and signing on LDAP requests.

        :return: The ldap_sign_and_seal of this ProvidersAdsAdsItemExtended.
        :rtype: bool
        """
        return self._ldap_sign_and_seal

    @ldap_sign_and_seal.setter
    def ldap_sign_and_seal(self, ldap_sign_and_seal):
        """
        Sets the ldap_sign_and_seal of this ProvidersAdsAdsItemExtended.
        Enables encryption and signing on LDAP requests.

        :param ldap_sign_and_seal: The ldap_sign_and_seal of this ProvidersAdsAdsItemExtended.
        :type: bool
        """
        
        self._ldap_sign_and_seal = ldap_sign_and_seal

    @property
    def login_shell(self):
        """
        Gets the login_shell of this ProvidersAdsAdsItemExtended.
        Specifies the login shell path.

        :return: The login_shell of this ProvidersAdsAdsItemExtended.
        :rtype: str
        """
        return self._login_shell

    @login_shell.setter
    def login_shell(self, login_shell):
        """
        Sets the login_shell of this ProvidersAdsAdsItemExtended.
        Specifies the login shell path.

        :param login_shell: The login_shell of this ProvidersAdsAdsItemExtended.
        :type: str
        """
        
        self._login_shell = login_shell

    @property
    def lookup_domains(self):
        """
        Gets the lookup_domains of this ProvidersAdsAdsItemExtended.
        Limits user and group lookups to the specified domains.

        :return: The lookup_domains of this ProvidersAdsAdsItemExtended.
        :rtype: list[str]
        """
        return self._lookup_domains

    @lookup_domains.setter
    def lookup_domains(self, lookup_domains):
        """
        Sets the lookup_domains of this ProvidersAdsAdsItemExtended.
        Limits user and group lookups to the specified domains.

        :param lookup_domains: The lookup_domains of this ProvidersAdsAdsItemExtended.
        :type: list[str]
        """
        
        self._lookup_domains = lookup_domains

    @property
    def lookup_groups(self):
        """
        Gets the lookup_groups of this ProvidersAdsAdsItemExtended.
        Looks up AD groups in other providers before allocating a group ID.

        :return: The lookup_groups of this ProvidersAdsAdsItemExtended.
        :rtype: bool
        """
        return self._lookup_groups

    @lookup_groups.setter
    def lookup_groups(self, lookup_groups):
        """
        Sets the lookup_groups of this ProvidersAdsAdsItemExtended.
        Looks up AD groups in other providers before allocating a group ID.

        :param lookup_groups: The lookup_groups of this ProvidersAdsAdsItemExtended.
        :type: bool
        """
        
        self._lookup_groups = lookup_groups

    @property
    def lookup_normalize_groups(self):
        """
        Gets the lookup_normalize_groups of this ProvidersAdsAdsItemExtended.
        Normalizes AD group names to lowercase before look up.

        :return: The lookup_normalize_groups of this ProvidersAdsAdsItemExtended.
        :rtype: bool
        """
        return self._lookup_normalize_groups

    @lookup_normalize_groups.setter
    def lookup_normalize_groups(self, lookup_normalize_groups):
        """
        Sets the lookup_normalize_groups of this ProvidersAdsAdsItemExtended.
        Normalizes AD group names to lowercase before look up.

        :param lookup_normalize_groups: The lookup_normalize_groups of this ProvidersAdsAdsItemExtended.
        :type: bool
        """
        
        self._lookup_normalize_groups = lookup_normalize_groups

    @property
    def lookup_normalize_users(self):
        """
        Gets the lookup_normalize_users of this ProvidersAdsAdsItemExtended.
        Normalize AD user names to lowercase before look up.

        :return: The lookup_normalize_users of this ProvidersAdsAdsItemExtended.
        :rtype: bool
        """
        return self._lookup_normalize_users

    @lookup_normalize_users.setter
    def lookup_normalize_users(self, lookup_normalize_users):
        """
        Sets the lookup_normalize_users of this ProvidersAdsAdsItemExtended.
        Normalize AD user names to lowercase before look up.

        :param lookup_normalize_users: The lookup_normalize_users of this ProvidersAdsAdsItemExtended.
        :type: bool
        """
        
        self._lookup_normalize_users = lookup_normalize_users

    @property
    def lookup_users(self):
        """
        Gets the lookup_users of this ProvidersAdsAdsItemExtended.
        Looks up AD users in other providers before allocating a user ID.

        :return: The lookup_users of this ProvidersAdsAdsItemExtended.
        :rtype: bool
        """
        return self._lookup_users

    @lookup_users.setter
    def lookup_users(self, lookup_users):
        """
        Sets the lookup_users of this ProvidersAdsAdsItemExtended.
        Looks up AD users in other providers before allocating a user ID.

        :param lookup_users: The lookup_users of this ProvidersAdsAdsItemExtended.
        :type: bool
        """
        
        self._lookup_users = lookup_users

    @property
    def machine_account(self):
        """
        Gets the machine_account of this ProvidersAdsAdsItemExtended.
        Specifies the SAM account name of the machine account.

        :return: The machine_account of this ProvidersAdsAdsItemExtended.
        :rtype: str
        """
        return self._machine_account

    @machine_account.setter
    def machine_account(self, machine_account):
        """
        Sets the machine_account of this ProvidersAdsAdsItemExtended.
        Specifies the SAM account name of the machine account.

        :param machine_account: The machine_account of this ProvidersAdsAdsItemExtended.
        :type: str
        """
        
        self._machine_account = machine_account

    @property
    def machine_name(self):
        """
        Gets the machine_name of this ProvidersAdsAdsItemExtended.
        Specifies name to join AD as.

        :return: The machine_name of this ProvidersAdsAdsItemExtended.
        :rtype: str
        """
        return self._machine_name

    @machine_name.setter
    def machine_name(self, machine_name):
        """
        Sets the machine_name of this ProvidersAdsAdsItemExtended.
        Specifies name to join AD as.

        :param machine_name: The machine_name of this ProvidersAdsAdsItemExtended.
        :type: str
        """
        
        self._machine_name = machine_name

    @property
    def machine_password_changes(self):
        """
        Gets the machine_password_changes of this ProvidersAdsAdsItemExtended.
        Enables periodic changes of the machine password for security.

        :return: The machine_password_changes of this ProvidersAdsAdsItemExtended.
        :rtype: bool
        """
        return self._machine_password_changes

    @machine_password_changes.setter
    def machine_password_changes(self, machine_password_changes):
        """
        Sets the machine_password_changes of this ProvidersAdsAdsItemExtended.
        Enables periodic changes of the machine password for security.

        :param machine_password_changes: The machine_password_changes of this ProvidersAdsAdsItemExtended.
        :type: bool
        """
        
        self._machine_password_changes = machine_password_changes

    @property
    def machine_password_lifespan(self):
        """
        Gets the machine_password_lifespan of this ProvidersAdsAdsItemExtended.
        Sets maximum age of a password in seconds.

        :return: The machine_password_lifespan of this ProvidersAdsAdsItemExtended.
        :rtype: int
        """
        return self._machine_password_lifespan

    @machine_password_lifespan.setter
    def machine_password_lifespan(self, machine_password_lifespan):
        """
        Sets the machine_password_lifespan of this ProvidersAdsAdsItemExtended.
        Sets maximum age of a password in seconds.

        :param machine_password_lifespan: The machine_password_lifespan of this ProvidersAdsAdsItemExtended.
        :type: int
        """
        
        if machine_password_lifespan is not None  and machine_password_lifespan > 3.1536E7:
            raise ValueError("Invalid value for `machine_password_lifespan`, must be a value less than or equal to `3.1536E7`")
        if machine_password_lifespan is not None and machine_password_lifespan < 3600.0:
            raise ValueError("Invalid value for `machine_password_lifespan`, must be a value greater than or equal to `3600.0`")

        self._machine_password_lifespan = machine_password_lifespan

    @property
    def name(self):
        """
        Gets the name of this ProvidersAdsAdsItemExtended.
        Specifies the Active Directory provider name.

        :return: The name of this ProvidersAdsAdsItemExtended.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this ProvidersAdsAdsItemExtended.
        Specifies the Active Directory provider name.

        :param name: The name of this ProvidersAdsAdsItemExtended.
        :type: str
        """
        
        self._name = name

    @property
    def netbios_domain(self):
        """
        Gets the netbios_domain of this ProvidersAdsAdsItemExtended.
        Specifies the NetBIOS domain name associated with the machine account.

        :return: The netbios_domain of this ProvidersAdsAdsItemExtended.
        :rtype: str
        """
        return self._netbios_domain

    @netbios_domain.setter
    def netbios_domain(self, netbios_domain):
        """
        Sets the netbios_domain of this ProvidersAdsAdsItemExtended.
        Specifies the NetBIOS domain name associated with the machine account.

        :param netbios_domain: The netbios_domain of this ProvidersAdsAdsItemExtended.
        :type: str
        """
        
        self._netbios_domain = netbios_domain

    @property
    def node_dc_affinity(self):
        """
        Gets the node_dc_affinity of this ProvidersAdsAdsItemExtended.
        Specifies the domain controller for which the node has affinity.

        :return: The node_dc_affinity of this ProvidersAdsAdsItemExtended.
        :rtype: str
        """
        return self._node_dc_affinity

    @node_dc_affinity.setter
    def node_dc_affinity(self, node_dc_affinity):
        """
        Sets the node_dc_affinity of this ProvidersAdsAdsItemExtended.
        Specifies the domain controller for which the node has affinity.

        :param node_dc_affinity: The node_dc_affinity of this ProvidersAdsAdsItemExtended.
        :type: str
        """
        
        self._node_dc_affinity = node_dc_affinity

    @property
    def node_dc_affinity_timeout(self):
        """
        Gets the node_dc_affinity_timeout of this ProvidersAdsAdsItemExtended.
        Specifies the timeout for the domain controller for which the local node has affinity.

        :return: The node_dc_affinity_timeout of this ProvidersAdsAdsItemExtended.
        :rtype: int
        """
        return self._node_dc_affinity_timeout

    @node_dc_affinity_timeout.setter
    def node_dc_affinity_timeout(self, node_dc_affinity_timeout):
        """
        Sets the node_dc_affinity_timeout of this ProvidersAdsAdsItemExtended.
        Specifies the timeout for the domain controller for which the local node has affinity.

        :param node_dc_affinity_timeout: The node_dc_affinity_timeout of this ProvidersAdsAdsItemExtended.
        :type: int
        """
        
        self._node_dc_affinity_timeout = node_dc_affinity_timeout

    @property
    def nss_enumeration(self):
        """
        Gets the nss_enumeration of this ProvidersAdsAdsItemExtended.
        Enables the Active Directory provider to respond to 'getpwent' and 'getgrent' requests.

        :return: The nss_enumeration of this ProvidersAdsAdsItemExtended.
        :rtype: bool
        """
        return self._nss_enumeration

    @nss_enumeration.setter
    def nss_enumeration(self, nss_enumeration):
        """
        Sets the nss_enumeration of this ProvidersAdsAdsItemExtended.
        Enables the Active Directory provider to respond to 'getpwent' and 'getgrent' requests.

        :param nss_enumeration: The nss_enumeration of this ProvidersAdsAdsItemExtended.
        :type: bool
        """
        
        self._nss_enumeration = nss_enumeration

    @property
    def primary_domain(self):
        """
        Gets the primary_domain of this ProvidersAdsAdsItemExtended.
        Specifies the AD domain to which the provider is joined.

        :return: The primary_domain of this ProvidersAdsAdsItemExtended.
        :rtype: str
        """
        return self._primary_domain

    @primary_domain.setter
    def primary_domain(self, primary_domain):
        """
        Sets the primary_domain of this ProvidersAdsAdsItemExtended.
        Specifies the AD domain to which the provider is joined.

        :param primary_domain: The primary_domain of this ProvidersAdsAdsItemExtended.
        :type: str
        """
        
        self._primary_domain = primary_domain

    @property
    def restrict_findable(self):
        """
        Gets the restrict_findable of this ProvidersAdsAdsItemExtended.
        Check the provider for filtered lists of findable and unfindable users and groups.

        :return: The restrict_findable of this ProvidersAdsAdsItemExtended.
        :rtype: bool
        """
        return self._restrict_findable

    @restrict_findable.setter
    def restrict_findable(self, restrict_findable):
        """
        Sets the restrict_findable of this ProvidersAdsAdsItemExtended.
        Check the provider for filtered lists of findable and unfindable users and groups.

        :param restrict_findable: The restrict_findable of this ProvidersAdsAdsItemExtended.
        :type: bool
        """
        
        self._restrict_findable = restrict_findable

    @property
    def sfu_support(self):
        """
        Gets the sfu_support of this ProvidersAdsAdsItemExtended.
        Specifies whether to support RFC 2307 attributes on ADS domain controllers.

        :return: The sfu_support of this ProvidersAdsAdsItemExtended.
        :rtype: str
        """
        return self._sfu_support

    @sfu_support.setter
    def sfu_support(self, sfu_support):
        """
        Sets the sfu_support of this ProvidersAdsAdsItemExtended.
        Specifies whether to support RFC 2307 attributes on ADS domain controllers.

        :param sfu_support: The sfu_support of this ProvidersAdsAdsItemExtended.
        :type: str
        """
        allowed_values = ["none", "rfc2307"]
        if sfu_support is not None and sfu_support not in allowed_values:
            raise ValueError(
                "Invalid value for `sfu_support`, must be one of {0}"
                .format(allowed_values)
            )

        self._sfu_support = sfu_support

    @property
    def site(self):
        """
        Gets the site of this ProvidersAdsAdsItemExtended.
        Specifies the site for the Active Directory.

        :return: The site of this ProvidersAdsAdsItemExtended.
        :rtype: str
        """
        return self._site

    @site.setter
    def site(self, site):
        """
        Sets the site of this ProvidersAdsAdsItemExtended.
        Specifies the site for the Active Directory.

        :param site: The site of this ProvidersAdsAdsItemExtended.
        :type: str
        """
        
        self._site = site

    @property
    def status(self):
        """
        Gets the status of this ProvidersAdsAdsItemExtended.
        Specifies the status of the provider.

        :return: The status of this ProvidersAdsAdsItemExtended.
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """
        Sets the status of this ProvidersAdsAdsItemExtended.
        Specifies the status of the provider.

        :param status: The status of this ProvidersAdsAdsItemExtended.
        :type: str
        """
        
        self._status = status

    @property
    def store_sfu_mappings(self):
        """
        Gets the store_sfu_mappings of this ProvidersAdsAdsItemExtended.
        Stores SFU mappings permanently in the ID mapper.

        :return: The store_sfu_mappings of this ProvidersAdsAdsItemExtended.
        :rtype: bool
        """
        return self._store_sfu_mappings

    @store_sfu_mappings.setter
    def store_sfu_mappings(self, store_sfu_mappings):
        """
        Sets the store_sfu_mappings of this ProvidersAdsAdsItemExtended.
        Stores SFU mappings permanently in the ID mapper.

        :param store_sfu_mappings: The store_sfu_mappings of this ProvidersAdsAdsItemExtended.
        :type: bool
        """
        
        self._store_sfu_mappings = store_sfu_mappings

    @property
    def system(self):
        """
        Gets the system of this ProvidersAdsAdsItemExtended.
        If set to true, indicates that this provider instance was created by OneFS and cannot be removed.

        :return: The system of this ProvidersAdsAdsItemExtended.
        :rtype: bool
        """
        return self._system

    @system.setter
    def system(self, system):
        """
        Sets the system of this ProvidersAdsAdsItemExtended.
        If set to true, indicates that this provider instance was created by OneFS and cannot be removed.

        :param system: The system of this ProvidersAdsAdsItemExtended.
        :type: bool
        """
        
        self._system = system

    @property
    def unfindable_groups(self):
        """
        Gets the unfindable_groups of this ProvidersAdsAdsItemExtended.
        Specifies groups that cannot be resolved by the provider.

        :return: The unfindable_groups of this ProvidersAdsAdsItemExtended.
        :rtype: list[str]
        """
        return self._unfindable_groups

    @unfindable_groups.setter
    def unfindable_groups(self, unfindable_groups):
        """
        Sets the unfindable_groups of this ProvidersAdsAdsItemExtended.
        Specifies groups that cannot be resolved by the provider.

        :param unfindable_groups: The unfindable_groups of this ProvidersAdsAdsItemExtended.
        :type: list[str]
        """
        
        self._unfindable_groups = unfindable_groups

    @property
    def unfindable_users(self):
        """
        Gets the unfindable_users of this ProvidersAdsAdsItemExtended.
        Specifies users that cannot be resolved by the provider.

        :return: The unfindable_users of this ProvidersAdsAdsItemExtended.
        :rtype: list[str]
        """
        return self._unfindable_users

    @unfindable_users.setter
    def unfindable_users(self, unfindable_users):
        """
        Sets the unfindable_users of this ProvidersAdsAdsItemExtended.
        Specifies users that cannot be resolved by the provider.

        :param unfindable_users: The unfindable_users of this ProvidersAdsAdsItemExtended.
        :type: list[str]
        """
        
        self._unfindable_users = unfindable_users

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

