# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class ProvidersSummaryProviderInstanceConnection(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        ProvidersSummaryProviderInstanceConnection - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'address': 'str',
            'last_used': 'str',
            'server': 'str'
        }

        self.attribute_map = {
            'address': 'address',
            'last_used': 'last_used',
            'server': 'server'
        }

        self._address = None
        self._last_used = None
        self._server = None

    @property
    def address(self):
        """
        Gets the address of this ProvidersSummaryProviderInstanceConnection.
        Specifies the IP address of the provider.

        :return: The address of this ProvidersSummaryProviderInstanceConnection.
        :rtype: str
        """
        return self._address

    @address.setter
    def address(self, address):
        """
        Sets the address of this ProvidersSummaryProviderInstanceConnection.
        Specifies the IP address of the provider.

        :param address: The address of this ProvidersSummaryProviderInstanceConnection.
        :type: str
        """
        
        self._address = address

    @property
    def last_used(self):
        """
        Gets the last_used of this ProvidersSummaryProviderInstanceConnection.
        Specifies the last time the server was contacted.

        :return: The last_used of this ProvidersSummaryProviderInstanceConnection.
        :rtype: str
        """
        return self._last_used

    @last_used.setter
    def last_used(self, last_used):
        """
        Sets the last_used of this ProvidersSummaryProviderInstanceConnection.
        Specifies the last time the server was contacted.

        :param last_used: The last_used of this ProvidersSummaryProviderInstanceConnection.
        :type: str
        """
        
        self._last_used = last_used

    @property
    def server(self):
        """
        Gets the server of this ProvidersSummaryProviderInstanceConnection.
        Specifies the fully qualified domain name of the server.

        :return: The server of this ProvidersSummaryProviderInstanceConnection.
        :rtype: str
        """
        return self._server

    @server.setter
    def server(self, server):
        """
        Sets the server of this ProvidersSummaryProviderInstanceConnection.
        Specifies the fully qualified domain name of the server.

        :param server: The server of this ProvidersSummaryProviderInstanceConnection.
        :type: str
        """
        
        self._server = server

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

