# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class SnapshotScheduleExtended(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        SnapshotScheduleExtended - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'alias': 'str',
            'duration': 'int',
            'id': 'int',
            'name': 'str',
            'next_run': 'int',
            'next_snapshot': 'str',
            'path': 'str',
            'pattern': 'str',
            'schedule': 'str'
        }

        self.attribute_map = {
            'alias': 'alias',
            'duration': 'duration',
            'id': 'id',
            'name': 'name',
            'next_run': 'next_run',
            'next_snapshot': 'next_snapshot',
            'path': 'path',
            'pattern': 'pattern',
            'schedule': 'schedule'
        }

        self._alias = None
        self._duration = None
        self._id = None
        self._name = None
        self._next_run = None
        self._next_snapshot = None
        self._path = None
        self._pattern = None
        self._schedule = None

    @property
    def alias(self):
        """
        Gets the alias of this SnapshotScheduleExtended.
        Alias name to create for each snapshot.

        :return: The alias of this SnapshotScheduleExtended.
        :rtype: str
        """
        return self._alias

    @alias.setter
    def alias(self, alias):
        """
        Sets the alias of this SnapshotScheduleExtended.
        Alias name to create for each snapshot.

        :param alias: The alias of this SnapshotScheduleExtended.
        :type: str
        """
        
        self._alias = alias

    @property
    def duration(self):
        """
        Gets the duration of this SnapshotScheduleExtended.
        Time in seconds added to creation time to construction expiration time.

        :return: The duration of this SnapshotScheduleExtended.
        :rtype: int
        """
        return self._duration

    @duration.setter
    def duration(self, duration):
        """
        Sets the duration of this SnapshotScheduleExtended.
        Time in seconds added to creation time to construction expiration time.

        :param duration: The duration of this SnapshotScheduleExtended.
        :type: int
        """
        
        self._duration = duration

    @property
    def id(self):
        """
        Gets the id of this SnapshotScheduleExtended.
        The system ID given to the schedule.

        :return: The id of this SnapshotScheduleExtended.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this SnapshotScheduleExtended.
        The system ID given to the schedule.

        :param id: The id of this SnapshotScheduleExtended.
        :type: int
        """
        
        self._id = id

    @property
    def name(self):
        """
        Gets the name of this SnapshotScheduleExtended.
        The schedule name.

        :return: The name of this SnapshotScheduleExtended.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this SnapshotScheduleExtended.
        The schedule name.

        :param name: The name of this SnapshotScheduleExtended.
        :type: str
        """
        
        self._name = name

    @property
    def next_run(self):
        """
        Gets the next_run of this SnapshotScheduleExtended.
        Unix Epoch time of next snapshot to be created.

        :return: The next_run of this SnapshotScheduleExtended.
        :rtype: int
        """
        return self._next_run

    @next_run.setter
    def next_run(self, next_run):
        """
        Sets the next_run of this SnapshotScheduleExtended.
        Unix Epoch time of next snapshot to be created.

        :param next_run: The next_run of this SnapshotScheduleExtended.
        :type: int
        """
        
        self._next_run = next_run

    @property
    def next_snapshot(self):
        """
        Gets the next_snapshot of this SnapshotScheduleExtended.
        Formatted name (see pattern) of next snapshot to be created.

        :return: The next_snapshot of this SnapshotScheduleExtended.
        :rtype: str
        """
        return self._next_snapshot

    @next_snapshot.setter
    def next_snapshot(self, next_snapshot):
        """
        Sets the next_snapshot of this SnapshotScheduleExtended.
        Formatted name (see pattern) of next snapshot to be created.

        :param next_snapshot: The next_snapshot of this SnapshotScheduleExtended.
        :type: str
        """
        
        self._next_snapshot = next_snapshot

    @property
    def path(self):
        """
        Gets the path of this SnapshotScheduleExtended.
        The /ifs path snapshotted.

        :return: The path of this SnapshotScheduleExtended.
        :rtype: str
        """
        return self._path

    @path.setter
    def path(self, path):
        """
        Sets the path of this SnapshotScheduleExtended.
        The /ifs path snapshotted.

        :param path: The path of this SnapshotScheduleExtended.
        :type: str
        """
        
        self._path = path

    @property
    def pattern(self):
        """
        Gets the pattern of this SnapshotScheduleExtended.
        Pattern expanded with strftime to create snapshot name.

        :return: The pattern of this SnapshotScheduleExtended.
        :rtype: str
        """
        return self._pattern

    @pattern.setter
    def pattern(self, pattern):
        """
        Sets the pattern of this SnapshotScheduleExtended.
        Pattern expanded with strftime to create snapshot name.

        :param pattern: The pattern of this SnapshotScheduleExtended.
        :type: str
        """
        
        self._pattern = pattern

    @property
    def schedule(self):
        """
        Gets the schedule of this SnapshotScheduleExtended.
        The isidate compatible natural language description of the schedule.

        :return: The schedule of this SnapshotScheduleExtended.
        :rtype: str
        """
        return self._schedule

    @schedule.setter
    def schedule(self, schedule):
        """
        Sets the schedule of this SnapshotScheduleExtended.
        The isidate compatible natural language description of the schedule.

        :param schedule: The schedule of this SnapshotScheduleExtended.
        :type: str
        """
        
        self._schedule = schedule

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

